const SQUASH_MERGE_COMMIT_HEADER = /^commit [a-f0-9]*$/;
const SQUASH_MERGE_AUTHOR_HEADER = /^Author: .*$/;
const SQUASH_MERGE_DATE_HEADER = /^Date: .*$/;
const SQUASH_MERGE_INDENT = "* ";

function findNextSquashCommit(lines, currentLine) {
  while (lines[currentLine] === "" && currentLine < lines.length) {
    currentLine++;
  }

  // const commit = SQUASH_MERGE_COMMIT_HEADER.exec(lines[currentLine++]);
  // const author = SQUASH_MERGE_AUTHOR_HEADER.exec(lines[currentLine++]);
  // const date = SQUASH_MERGE_DATE_HEADER.exec(lines[currentLine++]);
  // console.log("commit && author && date", commit, author, date);
  // if (!(commit && author && date)) {
  //   return { result: "error" };
  // }

  // if (!lines[currentLine].startsWith(SQUASH_MERGE_INDENT)) {
  //   return { result: "error" };
  // }

  let message = lines[currentLine].slice(SQUASH_MERGE_INDENT.length);
  console.log(
    ":::::::::::",
    currentLine < lines.length,
    !lines[currentLine].startsWith(SQUASH_MERGE_INDENT),
    lines[currentLine]
  );
  while (currentLine < lines.length && !lines[currentLine].startsWith(SQUASH_MERGE_INDENT)) {
    console.log(">>>>>>>>>>>>", lines[currentLine]);
    message += lines[currentLine];
    currentLine++;
  }
  currentLine++;

  return { result: "found", message: message.trim(), currentLine };
}

/**
 * A squash merge may have several commits masquerading as one.  This splits up
 * the commit message into an array of commits.  If the commit is not a squash
 * merge, returns `undefined`.
 *
 * @param {Object} commit - The commit.
 * @returns {Array | undefiend} - Array of commits, or `undefined`
 *   if this is not a squash merge.
 */
module.exports = function (commit) {
  let answer = [];

  const lines = commit.message.split(/\r|\n/);
  lines.forEach((l) => {
    if (l.startsWith("* ") || !answer.length) {
      if (answer.length) {
        answer[answer.length - 1].message = answer[answer.length - 1].message.trim();
      }
      answer.push({ message: l.startsWith("* ") ? l.slice(2) : l, squash: l.startsWith("* ") });
    } else {
      answer[answer.length - 1].message = answer[answer.length - 1].message + "\n" + l;
    }
  });
  // if (lines[0] === "Squashed commit of the following:") {
  //   let success = true;
  //   const commits = [];

  //   let currentLine = 1;
  //   console.log("lines.....", lines);
  //   while (currentLine < lines.length) {
  //     const nextCommit = findNextSquashCommit(lines, currentLine);
  //     console.log("nextCommit", nextCommit, lines[currentLine]);
  //     switch (nextCommit.result) {
  //       case "found":
  //         commits.push({
  //           message: nextCommit.message.startsWith("* ") ? nextCommit.message.replace("* ", "") : nextCommit.message,
  //           squash: true,
  //         });
  //         ({ currentLine } = nextCommit);
  //         break;
  //       case "error":
  //         console.log("========================");
  //         success = false;
  //         currentLine = lines.length;
  //         break;
  //       /* istanbul ignore next */
  //       default:
  //         throw new Error(`Unhandled case ${nextCommit.result}`);
  //     }
  //   }

  //   if (success) {
  //     answer = commits;
  //   }
  //   console.log("commits", commits);
  // }

  return answer;
};
